VERSION 5.00
Begin VB.UserControl menuButton 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   2175
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2640
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MaskColor       =   &H00FF00FF&
   ScaleHeight     =   145
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   176
   Begin VB.PictureBox pBtnPic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FF00FF&
      BorderStyle     =   0  'None
      Height          =   345
      Left            =   1320
      ScaleHeight     =   23
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   20
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Visible         =   0   'False
      Width           =   300
   End
End
Attribute VB_Name = "menuButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

''' Controll by AWP
''' (tdr2004@list.ru)

'Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal crTransparent As Long) As Long
Private Declare Function TextOut& Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long)
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long

'Events
Event Click()
Event MouseEnter()
Event MouseExit()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OLECompleteDrag(Effect As Long)
Event OLEDragOver(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
Event OLEDragDrop(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Event OLESetData(data As DataObject, DataFormat As Integer)
Event OLEStartDrag(data As DataObject, AllowedEffects As Long)

Dim m_Enabled   As Boolean

Dim m_Value     As Boolean

Dim m_Caption   As String

Dim m_Alignment As Long

Dim m_KeyColor  As Long

Dim m_ForeColor As Long

Dim iStatus     As Integer
Dim fins        As Boolean

Private Sub DrawValue()
    Dim X, Y, W, H, DT
    W = ScaleWidth
    H = ScaleHeight
    'If pBtnPic.Picture Then BitBlt hdc, (W - pBtnPic.ScaleWidth) / 2, (H - pBtnPic.ScaleHeight) / 2, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, pBtnPic.hdc, 0, 0, vbSrcCopy
    If pBtnPic.Picture Then TransparentBlt hdc, (W - pBtnPic.ScaleWidth) / 2, (H - pBtnPic.ScaleHeight) / 2, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, pBtnPic.hdc, 0, 0, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, KeyColor

    If m_Caption <> "" Then
        X = UserControl.TextWidth(m_Caption)
        Y = UserControl.TextHeight(m_Caption)
        DT = UserControl.TextWidth(".")
        Select Case m_Alignment
            Case 0
                TextOut hdc, DT, (H - Y) / 2, m_Caption, Len(m_Caption)
            Case 1
                TextOut hdc, (W - X) - DT, (H - Y) / 2, m_Caption, Len(m_Caption)
            Case 2
                TextOut hdc, CLng((W - X) / 2 - 0.5), (H - Y) / 2, m_Caption, Len(m_Caption)
        End Select
    End If
End Sub
Private Sub Render(Optional ByVal bPressed As Boolean = False, Optional ByVal bHover As Boolean = False)
    Dim X, Y, W, H
    W = ScaleWidth
    H = ScaleHeight
    Cls

    If m_Value = True Then
        Line (0, 0)-(W - 1, H - 1), RGB(192, 192, 192), BF
        DrawValue
        Line (0, 0)-(W - 1, H - 1), RGB(128, 128, 128), B
  
    Else

        DrawValue
  
        If bHover = True Then
            Line (0, 0)-(W - 1, H - 1), RGB(130, 130, 130), B
        End If
  
        If bPressed = True Then
            Line (0, 0)-(W - 1, H - 1), RGB(60, 60, 60), B
        End If

    End If

    Refresh
End Sub

Private Sub UserControl_ExitFocus()
    Render
    fins = False
    iStatus = 0
End Sub

Private Sub UserControl_InitProperties()
    m_Enabled = True
    m_Value = False
    m_Caption = "menuButton"
    m_KeyColor = vbMagenta
End Sub
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    If Button = 1 Then
        Render True
        iStatus = 1
    End If
End Sub
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim ret As Long

    If Button = vbLeftButton Then
        If iStatus = 1 Then
            If GetCapture() <> hwnd Then
                ret = SetCapture(hwnd)
                Render True
            End If
            If X > 0 And X < ScaleWidth And Y > 0 And Y < ScaleHeight Then
                Render True
            Else
                Render , True
            End If
        Else
        End If
    Else
        If X < 0 Or X > ScaleWidth Or Y < 0 Or Y > ScaleHeight Then
            fins = False
            ret = ReleaseCapture()
            RaiseEvent MouseExit
            Render
        Else
            If fins = False Then
                fins = True
                ret = SetCapture(UserControl.hwnd)
                RaiseEvent MouseEnter
                Render , True
            End If
        End If
    End If
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        If iStatus = 1 Then
            If X > 0 And X < ScaleWidth And Y > 0 And Y < ScaleHeight Then
                fins = False
                Render
                RaiseEvent Click
                iStatus = 0
            Else
                Render
                iStatus = 0
                fins = False
            End If 'XY Pos
        End If 'iStatus
    End If 'Mouse Button
    Render
    iStatus = 0
    fins = False
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub
Private Sub UserControl_OLEDragDrop(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(data, Effect, Button, Shift, X, Y)
End Sub
Private Sub UserControl_OLEDragOver(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(data, Effect, Button, Shift, X, Y, State)
End Sub
Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub
Private Sub UserControl_OLESetData(data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(data, DataFormat)
End Sub
Private Sub UserControl_OLEStartDrag(data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(data, AllowedEffects)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
 
    m_Enabled = PropBag.ReadProperty("Enabled", True)
 
    m_Value = PropBag.ReadProperty("Value", False)
   
    m_Caption = PropBag.ReadProperty("Caption", "menuButton")
 
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)

    m_KeyColor = PropBag.ReadProperty("KeyColor", vbMagenta)
 
    m_Alignment = PropBag.ReadProperty("Alignment", 2)
 
    Set pBtnPic.Picture = PropBag.ReadProperty("Picture", Nothing)

    Set Font = PropBag.ReadProperty("Font", UserControl.Ambient.Font)
 
    ForeColor = PropBag.ReadProperty("ForeColor", Ambient.ForeColor)
 
    UserControl.Enabled = m_Enabled
 
    Render
End Sub
Private Sub UserControl_Resize()
    Render
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", m_Enabled, True)
 
    Call PropBag.WriteProperty("Value", m_Value, False)
 
    Call PropBag.WriteProperty("Caption", m_Caption, "menuButton")
 
    Call PropBag.WriteProperty("Picture", pBtnPic.Picture, Nothing)
 
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
 
    Call PropBag.WriteProperty("KeyColor", m_KeyColor, vbMagenta)
 
    Call PropBag.WriteProperty("Font", UserControl.Font, UserControl.Ambient.Font)
 
    Call PropBag.WriteProperty("Alignment", m_Alignment, 2)
 
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, UserControl.Ambient.Font)
End Sub

''' ForeColor
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = UserControl.ForeColor
End Property
Public Property Let ForeColor(ByVal NewBool As OLE_COLOR)
    UserControl.ForeColor = NewBool
    PropertyChanged "ForeColor"
    DrawValue
End Property

''' ALIGNMENT
Public Property Get Alignment() As AlignmentConstants
    Alignment = m_Alignment
End Property
Public Property Let Alignment(ByVal NewBool As AlignmentConstants)
    m_Alignment = NewBool
    PropertyChanged "Alignment"
    Render
End Property

''' BakcColor
Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewBool As OLE_COLOR)
    UserControl.BackColor = NewBool
    PropertyChanged "BackColor"
    Render
End Property

''' CAPTION
Public Property Get Caption() As String
    Caption = m_Caption
End Property
Public Property Let Caption(ByVal NewBool As String)
    m_Caption = NewBool
    PropertyChanged "Caption"
    'UserControl.Value = m_Value
    Render
End Property

''' ENABLED
Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property
Public Property Let Enabled(ByVal NewBool As Boolean)
    m_Enabled = NewBool
    PropertyChanged "Enabled"
    UserControl.Enabled = m_Enabled
    Render
End Property

''' FONT
Public Property Get Font() As Font
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal vNewFont As Font)
    'Set m_Font = vNewFont
    Set UserControl.Font = vNewFont
    Call UserControl_Resize
    PropertyChanged "Font"
End Property

''' KeyColor
Public Property Get KeyColor() As OLE_COLOR
    KeyColor = m_KeyColor
End Property
Public Property Let KeyColor(ByVal NewBool As OLE_COLOR)
    m_KeyColor = NewBool
    PropertyChanged "KeyColor"
    Render
End Property

''' PICTURE
Public Property Get Picture() As StdPicture
    Set Picture = pBtnPic.Picture
End Property
Public Property Set Picture(ByVal NewPic As StdPicture)
    Set pBtnPic.Picture = NewPic
    PropertyChanged "Picture"
    Render
End Property

''' VALUE
Public Property Get value() As Boolean
Attribute value.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    value = m_Value
End Property
Public Property Let value(ByVal NewBool As Boolean)
    m_Value = NewBool
    PropertyChanged "Value"
    'UserControl.Value = m_Value
    Render
End Property

